{
  ͻ                   
   OpenSource Library                    
  ͼ                   
   Author : Vitaly Checkryzhev (Virtualik) 
   E-Mail : virty1k@mail.ru                
   WWW    : http://www.str.ru/~virty       
   WWW    : http://virtualsoft.narod.ru    
   WWW    : http://chat.str.ru             
                                           
  VIRtUal Soft         All rights reserved 
 
  
}
{  ࠭: 㣮쭨, אַ㣮쭨, 㦭.
  䥪⮬ ࠦ  ࠭ ࠭.
  ᯮ짮 ꥪ⮢  ᫥}

uses crt, graph;

const
 n1 = 20; {⢮ 㣮쭨}
 n2 = 20; {⢮ אַ㣮쭨}
 n3 = 20; {⢮ 㦭⥩}

type
 TFigure = object
   x0, y0,                   {न 業 䨣}
   Color,                    { 䨣}
   vx, vy: Integer;          { ᪮⥩  न⠬}
  constructor Init;          {樠 ꥪ}
  destructor  Done; virtual; {⮦ ꥪ}
  procedure   Show; virtual; {⮡ࠦ  ࠭}
  procedure   Hide; virtual; {  ࠭}
  procedure   Move;          {।,  न}
  procedure   Live;          {।  ᮢ}
 end;

 TTriangle = object(TFigure)
  x1,x2,x3,
  y1,y2,y3 : Integer; {न 設}
  constructor Init;   {樠 ꥪ}
  procedure   Show; virtual; {⮡ࠦ  ࠭}
  procedure   Hide; virtual; {  ࠭}
 end;

 TSquare = object(TFigure)
  x1,x2,y1,y2 : Integer; {न 㣫}
  constructor Init;      {樠 ꥪ}
  procedure   Show; virtual; {⮡ࠦ  ࠭}
  procedure   Hide; virtual; {  ࠭}
 end;

 TCircle = object(TFigure)
  Radius : Integer; {}
  constructor Init; {樠 ꥪ}
  procedure   Show; virtual; {⮡ࠦ  ࠭}
  procedure   Hide; virtual; {  ࠭}
 end;

{TFigure}

constructor TFigure.Init;
begin
 Color := Random(8) + 8;
 vx := Random(11) - 5;
 vy := Random(11) - 5;
 x0 := Random(GetMaxX);
 y0 := Random(GetMaxY);
 Show;
end;

destructor TFigure.Done;
begin
 {}
end;

procedure TFigure.Show;
begin
 {}
end;

procedure TFigure.Hide;
begin
 {}
end;

procedure TFigure.Move;
begin
 Inc(x0, vx);
 Inc(y0, vy);
 if (x0 < 0) or (x0 > GetMaxX) then
  begin
   vx := -vx;
   Inc(x0, vx);
  end;
 if (y0 < 0) or (y0 > GetMaxY) then
  begin
   vy := -vy;
   Inc(y0, vy);
  end;
end;

procedure TFigure.Live;
begin
 Hide;
 Move;
 Show;
end;

{TTriangle}

constructor TTriangle.Init;
begin
 x1 := Random(40) - 20;
 y1 := Random(40) - 20;
 x2 := Random(40) - 20;
 y2 := Random(40) - 20;
 x3 := Random(40) - 20;
 y3 := Random(40) - 20;
 inherited Init;
end;

procedure TTriangle.Show;
begin
 SetColor(Color);
 MoveTo(x0 + x1, y0 + y1);
 LineTo(x0 + x2, y0 + y2);
 LineTo(x0 + x3, y0 + y3);
 LineTo(x0 + x1, y0 + y1);
end;

procedure TTriangle.Hide;
begin
 SetColor(GetBkColor);
 MoveTo(x0 + x1, y0 + y1);
 LineTo(x0 + x2, y0 + y2);
 LineTo(x0 + x3, y0 + y3);
 LineTo(x0 + x1, y0 + y1);
end;

{TSquare}

constructor TSquare.Init;
begin
 x1 := - Random(10) - 10;
 y1 := - Random(10) - 10;
 x2 :=   Random(10) + 10;
 y2 :=   Random(10) + 10;
 inherited Init;
end;

procedure TSquare.Show;
begin
 SetColor(Color);
 Rectangle(x0 + x1,
           y0 + y1,
           x0 + x2,
           y0 + y2);
end;

procedure TSquare.Hide;
begin
 SetColor(GetBkColor);
 Rectangle(x0 + x1,
           y0 + y1,
           x0 + x2,
           y0 + y2);
end;

{TCircle}

constructor TCircle.Init;
begin
 Radius := Random(10) + 10;
 inherited Init;
end;

procedure TCircle.Show;
begin
 SetColor(Color);
 Circle(x0, y0, Radius);
end;

procedure TCircle.Hide;
begin
 SetColor(GetBkColor);
 Circle(x0, y0, Radius);
end;

var
 I : Integer;

 Triangle : Array [1..n1] of TTriangle;
 Square   : Array [1..n2] of TSquare;
 Circle   : Array [1..n3] of TCircle;

begin
 Randomize;
 InitGraph(I, I, '');

 {樠 ꥪ⮢}
 for I := 1 to n1 do
  Triangle[i].Init;

 for I := 1 to n2 do
  Circle[I].Init;

 for I := 1 to n3 do
  Square[I].Init;

 Repeat
  {६饭  ᮢ ꥪ⮢}
  for I := 1 to n1 do
   Triangle[i].Live;

  for I := 1 to n2 do
   Circle[I].Live;

  for I := 1 to n3 do
   Square[I].Live;
  Delay(50);
 Until KeyPressed;

 {᢮ }
 for I := 1 to n1 do
  Triangle[i].Done;

 for I := 1 to n2 do
  Circle[I].Done;

 for I := 1 to n3 do
  Square[I].Done;

 CloseGraph;
end.